 /*
  * lsmlib, STRASSER Michel may 2001
  *
  * This product is placed under GPL
  * Please see COPYING for further 
  * informations
  * ********************************
  *
  * this is the main.c file
  * *******************************/


#include <libxml/tree.h>

#include "lsm.h"
#include <libxml/tree.h>
#include <stdio.h>
#include <unistd.h> /* for getopt */

#define VERSION "0.2"
#define USAGE "usage: lsm [-h] [-o file] [dir] \n \
\n \
\th \t: print this help message\n \
\tv \t: print current version\n
\to file \t: use file as output \n\n\n\
"

int main(int argc, char **argv){
  FILE *fo;
  xmlDocPtr doc;
  int optch;
  static char optstring[]="o:hv";
  int optionO=0;
  char *dir; /* the directory to analyse */
  char currentDirectoryString[] =".";
  
  /* default initialisations */
  fo=stdout;
  dir=currentDirectoryString;

  /* processing options */

  while ( (optch = getopt(argc, argv, optstring)) != -1) {
    switch (optch) {
	    
      case 'h' :
	printf("lsm, version %s \n\n %s", VERSION, USAGE);
	return(0);
	break;
      
      case 'v' :
	printf("lsm, version %s\n", VERSION);
	return(0);
	break;
	
      case 'o' :
	optionO=1;
	if ((fo=fopen(optarg, "w"))==NULL) {
	  fprintf(stderr, "Error main, can not open %s in write mode", optarg);
	  return(1);
	}
	break;

      default :
	fprintf(stderr, "Unknown option : -%c", optch);
	return(1);
	break;
    }
  }

  /* processing arguments */

    /* if there is an argument more, it is the directory to analyse */
  if (optind < argc) {
    dir=argv[optind];
  }
  
  if ((doc=lsm_getTree(dir))==NULL) {
    fprintf(stdout, "lsm_getTree error");
    return(1);
  }
  xmlDocDump(fo, doc);
  if(optionO){
    fclose(fo);	
  }
  return(0); 
}	
